<?php
/*
description : Provide caching mechanism for plugins
author      : Ikuo Obataya
email       : I.Obataya@gmail.com
lastupdate  : 2008-05-14
license     : GPL 2 (http://www.gnu.org/licenses/gpl.html)
*/
if(!defined('DOKU_INC')) die();
class plugin_cache{
  var $namespace;
  var $mediaDir;
  var $mediaFormat;
  var $linkFormat;
  var $prefix;
  var $extension;
  function plugin_cache($_name='plugin_cache',$_prefix='noname',$_ext='txt'){
    global $conf;
    $this->namespace = strtolower($_name);
    $this->prefix    = strtolower($_prefix);
    $this->extension = strtolower($_ext);
    if (empty($_prefix)){
      $this->prefix = $_prefix;
    }else{
      $this->prefix = $_prefix.'_';
    }
    $delimiter = ($conf['useslash'])?'/':':';
    $this->mediaDir    = $conf['mediadir'].'/'.$this->namespace;
    $this->mediaFormat = $this->mediaDir.'/'.$this->prefix.'%s.'.$this->extension;
    $this->linkFormat  = $this->namespace.$delimiter.$this->prefix.'%s.'.$this->extension;

    $this->CheckDir();
  }
  
 /*
  * Get media file path
  */
  function GetMediaPath($id){
    $id = strtolower(urlencode($id));
    return sprintf($this->mediaFormat,$id);
  }  
 /**
  * Get media link
  */
  function GetMediaLink($id){
    return ml(sprintf($this->linkFormat,$id),'',true,'',true);
  }
  
 /**
  * Get text from cache. If none, return false
  */
  function GetMediaText($id){
    $id = strtolower(urlencode($id));
    $filepath = $this->GetMediaPath($id);
    if (@file_exists($filepath)){
      return io_readFile($filepath);
    }
    return false;
  }  
 /**
  * Check cache directories
  */
  function CheckDir(){
    global $conf;
    $pagedir = $conf['pagedir'].'/'.$this->namespace;
    if (!is_dir($pagedir)){    // Check page directory
      $content = "Here is a namespace for ".$this->namespace." cache.";
      saveWikiText($this->namespace.':'.$conf['start'],$content,"");
    }

    if (!is_dir($this->mediaDir))    // Check media directory
      @mkdir($this->mediaDir, $conf['dmode']);

    if (auth_aclcheck($this->namespace.":".$conf['start'],"","@ALL")==0){
       global $AUTH_ACL;
       $acl = join("",file(DOKU_CONF.'acl.auth.php'));
       $p_acl = $this->namespace.":*\t@ALL\t1\n";
       $new_acl = $acl.$p_acl;
       io_saveFile(DOKU_CONF.'acl.auth.php', $new_acl);
       $AUTH_ACL = file(DOKU_CONF.'acl.auth.php'); // Reload ACL
    }
  }

 /**
  * Clear all media files in a plugin's media directory
  */
  function ClearCache(){
    global $conf;
    $handle = @opendir($this->mediaDir);
    if ($handle === false)
      return;
    while (($entry = readdir($handle))){
      $path = $this->mediaDir.'/'.$entry;
      if(is_file($path))
          @unlink($path);
    }
    closedir($handle);    
  }
 /**
  * Remove cache and directory
  */
  function RemoveDir(){
    $this->ClearCache();
    @rmdir($this->mediaDir);
  }
}
