<?php
/**
 * DokuWiki plugin for Piwik
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Heikki Hokkanen <hoxu@users.sf.net>
 */

if(!defined('DOKU_INC')) define('DOKU_INC',realpath(dirname(__FILE__).'/../../').'/');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'admin.php');

/**
 * All DokuWiki plugins to extend the admin function
 * need to inherit from this class
 */
class admin_plugin_piwik extends DokuWiki_Admin_Plugin
{
	/**
	 * Constructor
	 */
	function admin_plugin_piwik()
	{
		$this->setupLocale();
	}

	/**
	 * return some info
	 */
	function getInfo()
	{
		return array(
			'author' => 'Heikki Hokkanen',
			'email'  => 'hoxu@users.sf.net',
			'date'   => '2008-06-22',
			'name'   => 'Piwik Plugin',
			'desc'   => 'Plugin to track wiki usage with Piwik web analytics',
			'url'    => 'http://wiki.splitbrain.org/plugin:piwik',
		);
	}

	/**
	 * return sort order for position in admin menu
	 */
	function getMenuSort()
	{
		return 999;
	}
	
	/**
	 *  return a menu prompt for the admin menu
	 *  NOT REQUIRED - its better to place $lang['menu'] string in localised string file
	 *  only use this function when you need to vary the string returned
	 */
	function getMenuText()
	{
		// TODO: change depending on whether the plugin is configured or not?
		return 'Piwik';
	}

	/**
	 * handle user request
	 */
	function handle()
	{
		if (!isset($_REQUEST['cmd'])) return;   // first time - nothing to do

		if (!is_array($_REQUEST['cmd'])) return;
	}

	/**
	 * output appropriate html
	 */
	function html()
	{
		ptln($this->locale_xhtml('help'));

		$idsite = $this->getConf('piwik_idsite');
		if ($idsite == 0) {
			ptln('<p><font color="red">'. $this->getLang('not_configured') .'</font></p>');
		}

		// check whether the template has been edited yet
		if (file_exists(DOKU_TPLINC .'main.php')) {
			$data = file_get_contents(DOKU_TPLINC .'main.php');
			if (!strstr($data, 'piwik_code()')) {
				ptln('<p><font color="red">'. $this->getLang('template_not_edited') .'</font></p>');
			} else {
				ptln('<p><font color="green">'. $this->getLang('template_edited_ok') .'</font></p>');
			}
		}
	}
}

