<?php
/**
 * DokuWiki plugin for Piwik
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Heikki Hokkanen <hoxu@users.sf.net>
 */

/**
 * Prints the snippet needed for Piwik.
 * This file should be included and the function called from the template files.
 */
function piwik_code()
{
	global $conf;

	if (isset($conf['plugin']['piwik']['piwik_idsite'])) {
		// Config does not contain keys if they are default;
		// so check whether they are set & to non-default value
		
		// default 0, so check if it's not set or 0
		if (!isset($conf['plugin']['piwik']['count_admins']) || $conf['plugin']['piwik']['count_admins'] == 0) {
			// TODO should perhaps check groups rather than just superuser
			if (isset($_SERVER['REMOTE_USER']) && $_SERVER['REMOTE_USER'] == $conf['superuser']) { return; }
		}
		
		// default 1, so check if it's set and 0
		if (isset($conf['plugin']['piwik']['count_users']) && $conf['plugin']['piwik']['count_users'] == 0) {
			if (isset($_SERVER['REMOTE_USER'])) { return; }
		}

		$idsite = $conf['plugin']['piwik']['piwik_idsite'];
		$piwik_url = $conf['plugin']['piwik']['piwik_url'];
		$piwik_url = rtrim($piwik_url, '/') . '/'; // Make sure the URL has '/' in the end

		ptln(
'<a href="http://piwik.org" title="Free analytics" onclick="window.open(this.href);return(false);">
<script language="javascript" src="'. $piwik_url .'piwik.js" type="text/javascript"></script>
<script type="text/javascript">
<!--
piwik_action_name = \'\';
piwik_idsite = '. $idsite .';
piwik_url = \''. $piwik_url .'piwik.php\';
piwik_log(piwik_action_name, piwik_idsite, piwik_url);
//-->
</script><object>
<noscript><p>Free analytics <img src="'. $piwik_url .'piwik.php" style="border:0" alt="piwik"/></p>
</noscript></object></a>
');
	}
}

